/* EPITA SPE 2010/2011       */
/* Contrôle 2 - Février 2011 */
/* question11                */

#define QNUM 11
#define QOPT "graine taille clef"
#define QNOPT 3

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include "base_test.h"
#include "question11.h"

#define randChar ((char)('a' + (random()%26)))

void randomString(char s[], size_t len)
{
  for (unsigned i=0; i<len; i++)
    s[i] = randChar;
}

blist build_list(size_t len)
{
  blist			tmp, l=NULL;
  for (size_t i=0; i<len; i++)
    {
      tmp = l;
      l = malloc(sizeof (struct s_blist));
      l->next = tmp;
      l->sup = -1;
      l->inf = 4097;
      l->size = 1 + random()%8;
      for (size_t j=0; j<l->size ; j++)
	{
	  l->keys[j] = random()%4096;
	  l->inf = l->inf < l->keys[j] ? l->inf : l->keys[j];
	  l->sup = l->sup > l->keys[j] ? l->sup : l->keys[j];
	  l->values[j] = malloc(5);
	  randomString(l->values[j], 4);
	  ((char*)(l->values[j]))[4] = 0;
	}
    }
  return l;
}

void print_seg(blist l)
{
  printf("[inf=%04d; sup=%04d; size=%02d]\n",l->inf, l->sup, l->size);
  for (size_t i=0; i<l->size; i++)
    {
      printf("  {%04d -> %s}\n",l->keys[i], (char*)(l->values[i]));
    }
}

void print(blist l)
{
  printf("l =\n");
  for (; l; l = l->next)
    print_seg(l);
}

int main(int argc,char *argv[])
{
  size_t        size;
  int		key;
  blist		l;

  help_asked(argc,argv,QNUM,QOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      key = atoi(argv[3]);
      l = build_list(size);
      print(l);
      printf("find(%04d,l) = %s\n", key, (char*)find(key,l));
    }
  exit(0);
}
